<?php
namespace zeradun\api_manager\includes\Ember\ClassLibrary\layout\attributes;

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Interface Alt
 *
 *
 * PHP versions 4 and 5
 *
 * Copyright notice
 *
 * (c) 2007 Sebastian Winterhalder <sebi@concastic.ch>
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 */

/*
 * Place includes, constant defines and $_GLOBAL settings here.
 */

/**
 * Abstract Class of Attributes.
 * Every Attributes inherits this class
 *
 *
 *
 * @category HTML Library
 * @package interface
 * @author Sebastian Winterhalder <sebi@concastic.ch>
 * @copyright 2007 Concastic
 * @license http://www.gnu.org/copyleft/gpl.html.
 * @version Release: @package_version@
 * @since Class available since Release 1.0.0
 *       
 */
abstract class htmlib_attribute {
	protected $attribute = - 1;
	
	/**
	 * Constructor with Optional Parameters
	 *
	 * @param Mixed $attribute        	
	 */
	public function __construct($attribute = -1) {
		$this->setAttribute ( $attribute );
	}
	
	/**
	 * Abstract definition of getAttribute
	 */
	public abstract function getAttribute();
	protected function setAttribute($attribute) {
		$this->attribute = $attribute;
	}
	
	/**
	 * Get the Attribute
	 *
	 * @return Mixed
	 */
	public function getAttributeValue() {
		return $this->attribute;
	}
}
?>